Subject: Re: bug#75585: 30.0.92; eww does not use proper file names for downloaded webpages

From: Anush V <[email-masked]>
Date: Fri, 17 Jan 2025 09:57:00 -0500

> From: Eli Zaretskii <[email-masked]>
> Date: Thu, 16 Jan 2025 17:39:33 +0200
>
>> From: Anush V <[email-masked]>
>> Date: Wed, 15 Jan 2025 09:57:25 -0500
>>
>> Hello Maintainers,
>>
>> I believe eww is not using proper names for downloaded webpages.
>>
>> Expected Behavior: Downloaded webpages should have a filename
>> reflecting the full url with an .html extension.
>
> That's not what eww-download does.  It downloads the pages to the
> directory specified by eww-download-directory, by default
> "~/Downloads".

Thank you for clarifying.

>> 1. When I download the page https://www.gnu.org/, eww downloads the
>> file without an .html extension, naming it simply as !.
>
> This page has no name.  We invent some name, in this case "!".  Apart
> of documenting this, why is that a problem?

Yes documenting this should help.

>> 2. When I download https://www.gnu.org/home.html, eww names the file
>> 'home.html'. While the extension is correct, shouldn't the filename
>> reflect the full URL to avoid conflicts when downloading 'home.html'
>> from different sites?

Sure, I wasn't clear about how eww-download works.

> eww-download detects conflicts and makes the downloaded name unique,
> see eww-make-unique-file-name.  This seems to be a deliberate design
> decision, and I can't say it sounds wrong to me.
>
> So, given that we augment the documentation to make these aspects
> clear, do you still think there's a bug here?

Just adding to the documentation should be sufficient.

My usecase, was to download webpage for offline reading.  I came
across eww-download (Downloads URL) and eww-open-file (renders html
file only if file has .html extension).  I thought I could download
webpages using eww-download and then read offline using eww-open-file

Regards,
Anush